/* -*-c++-*- */
/* $Header: VMMCALLS.C, 1, 9/11/99 6:52:13 PM, StarTeam VTS Administrator$ */
/*
** Copyright (c) 1999-1999, 3Dfx Interactive, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of 3Dfx Interactive, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of 3Dfx Interactive, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished  -
** rights reserved under the Copyright Laws of the United States.
**
** File name:   vmmcalls.c
**
** Description: use extra vmmcalls that cannot be used if h3vdd.h is included
**
** $Revision: 1$
** $Date: 9/11/99 6:52:13 PM$
**
** $History: VMMCALLS.C $
** 
** *****************  Version 4  *****************
** User: Xingc        Date: 3/29/99    Time: 7:25a
** Updated in $/devel/h3/Win95/dx/minivdd
** Delete an int 3
** 
** *****************  Version 3  *****************
** User: Xingc        Date: 3/26/99    Time: 12:20p
** Updated in $/devel/h3/Win95/dx/minivdd
** Preserve ECX and EDX befor make VMMCALL
** 
** *****************  Version 2  *****************
** User: Xingc        Date: 3/25/99    Time: 5:47p
** Updated in $/devel/h3/Win95/dx/minivdd
** Add an int 3 for test
** 
** *****************  Version 1  *****************
** User: Xingc        Date: 3/24/99    Time: 10:09a
** Created in $/devel/h3/Win95/dx/minivdd
** Use extra VMMCalls that cannot be used if h3vdd.h is included
**
*/

#define WANTVXDWRAPS
#include <basedef.h>
#include <VXDWraps.h>
#include <VMM.h>
#include <debug.h>
#include <vwin32.h>

DWORD PhysicalToLinear( DWORD dwPhysical)
{
 DWORD dwRet;
   _asm push ecx         //keep ecx,edx
   _asm push edx
   _asm push 0
   _asm push 0x400       //one page only
   _asm push dwPhysical
   VMMCall (_MapPhysToLinear);
   _asm add  esp, 12
   _asm pop  edx
   _asm pop  ecx
   _asm mov    dwRet,eax

  return dwRet;
}

DWORD GetDBLinear(DWORD  DBLinear )
{
  DWORD dwRet;
  DWORD dwOffset;
  DWORD dwPhysAddr;
  DWORD dwLocked;
   //First find the physcal address of DBLinear
    _asm mov    eax, cr3
    _asm mov    dwRet, eax
    dwRet = PhysicalToLinear( dwRet & 0xFFFFF000);

    if( dwRet == 0xFFFFFFFF)
       return 1;      //Error
    //Now dwRet has the linear address of CR3

    dwOffset = DBLinear >> 22;
    dwRet +=dwOffset * 4;
    //find page table address -- a physical address
    dwOffset = * ((DWORD *)dwRet);

    dwRet = PhysicalToLinear( dwOffset & 0xFFFFF000);

    if( dwRet == 0xFFFFFFFF)
       return 2;

    dwOffset = (DBLinear & 0x3FF000) >> 12;
    dwRet +=dwOffset * 4;
    //find page start address -- a physical address
    dwPhysAddr = * ((DWORD *)dwRet);

    //Reserve on page of linear address to map to
    //this physical address too.
    _asm  push  ecx         //keep ecx 
    _asm  push  edx         //keep edx 
    _asm  push  PR_FIXED
    _asm  push  1
    _asm  push  PR_SHARED
    VMMCall (_PageReserve);
    _asm  add  esp, 12
    _asm  pop  edx
    _asm  pop  ecx
    _asm  mov   dwRet,eax

    if( dwRet == 0xFFFFFFFF)
       return 3;

    dwLocked = dwRet;
    dwPhysAddr >>= 12;
    dwRet >>= 12;

     _asm push  ecx         //keep ecx 
     _asm push  edx         //keep edx 
     _asm push  PC_USER|PC_WRITEABLE
     _asm push  dwPhysAddr
     _asm push  1
     _asm push  dwRet
     VMMCall (_PageCommitPhys);
     _asm  add  esp, 16
     _asm  pop  edx
     _asm  pop  ecx
     _asm mov dwRet ,eax

     if( !dwRet )
         return 4;

     //Page lock it
      _asm push ecx
      _asm push PAGEMAPGLOBAL
      _asm push 1
      _asm mov  eax, dwLocked
      _asm shr  eax, 12
      _asm push eax
      VMMCall (_LinPageLock);
     _asm  add  esp, 12
     _asm  pop  ecx

      dwLocked |= DBLinear & 0xFFF;

      return dwLocked;

}

DWORD GetExtraAddr(DIOCPARAMETERS * lpParams)
{
   if( (lpParams->cbOutBuffer >= 4) &&
       ( lpParams->cbInBuffer >= 4))
   {
      *(DWORD *)lpParams->lpvOutBuffer = GetDBLinear( *(DWORD *)lpParams->lpvInBuffer);
      return 0;
    }
    else
      return 1;
}
/****************************************************************************
*                                                                           *
* THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY     *
* KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE       *
* IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR     *
* PURPOSE.                                                                  *
*                                                                           *
* Copyright (C) 1993-95  Microsoft Corporation.  All Rights Reserved.       *
*                                                                           *
****************************************************************************/

/******************************************************************************
 *
 *   Title:	VPICD.H - Include file for Virtual PIC Device
 *
 *   Version:	3.10
 *
 ******************************************************************************/

/*INT32*/

// Equates for result from VPICD_Get_Status

#define	VPICD_STAT_IRET_PENDING     	0x01
#define	VPICD_STAT_IRET_PENDING_BIT 	0
#define	VPICD_STAT_IN_SERVICE	    	0x02
#define	VPICD_STAT_IN_SERVICE_BIT   	1
#define	VPICD_STAT_PHYS_MASK	    	0x04
#define	VPICD_STAT_PHYS_MASK_BIT    	2
#define	VPICD_STAT_PHYS_IN_SERV     	0x08
#define	VPICD_STAT_PHYS_IN_SERV_BIT 	3
#define	VPICD_STAT_VIRT_MASK	    	0x10
#define	VPICD_STAT_VIRT_MASK_BIT    	4
#define	VPICD_STAT_VIRT_REQ	    	0x20
#define	VPICD_STAT_VIRT_REQ_BIT     	5
#define	VPICD_STAT_PHYS_REQ	    	0x40
#define	VPICD_STAT_PHYS_REQ_BIT     	6
#define	VPICD_STAT_VIRT_DEV_REQ     	0x80
#define	VPICD_STAT_VIRT_DEV_REQ_BIT 	7
#define VPICD_STAT_GLOBAL		0x100
#define VPICD_STAT_GLOBAL_BIT		8
#define VPICD_STAT_OWNED_BY_VM		0x200
#define VPICD_STAT_OWNED_BY_VM_BIT	9

// Equates for options in IRQ Descriptor

#define	VPICD_OPT_READ_HW_IRR	    	0x01
#define	VPICD_OPT_READ_HW_IRR_BIT   	0
#define	VPICD_OPT_CAN_SHARE	    	0x02
#define	VPICD_OPT_CAN_SHARE_BIT		1
#define	VPICD_OPT_REF_DATA	    	0x04		// new for 4.0
#define	VPICD_OPT_REF_DATA_BIT		2
#define	VPICD_OPT_VIRT_INT_REJECT    	0x10		// new for 4.0
#define VPICD_OPT_VIRT_INT_REJECT_BIT	4
#define VPICD_OPT_SHARE_PMODE_ONLY	0x20		// new for 4.0
#define VPICD_OPT_SHARE_PMODE_ONLY_BIT	5
#define VPICD_OPT_ALL			0x3F		// Internal use

// Equates for VPICD_Force_Default_Owner service.  Flags passed in high word
// of IRQ number

#define VPICD_FDO_NO_CONTENTION 	0x10000 	// new for 4.0
#define VPICD_FDO_NO_CONTENTION_BIT	16
#define VPICD_FDO_FAVOR_FOCUS		0x20000 	// new for 4.0
#define VPICD_FDO_FAVOR_FOCUS_BIT	17

typedef struct VPICD_IRQ_Descriptor {
    USHORT VID_IRQ_Number;
    USHORT VID_Options;			// INIT<0>
    ULONG VID_Hw_Int_Proc;
    ULONG VID_Virt_Int_Proc;		// INIT<0>
    ULONG VID_EOI_Proc;			// INIT<0>
    ULONG VID_Mask_Change_Proc;		// INIT<0>
    ULONG VID_IRET_Proc;		// INIT<0>
    ULONG VID_IRET_Time_Out;		// INIT<500>
    ULONG VID_Hw_Int_Ref;		// new for 4.0
} VID;

typedef VID *PVID;
typedef ULONG HIRQ;			// IRQ Handle

/*XLATOFF*/
#define	VPICD_Service	Declare_Service
#pragma warning (disable:4003)		// turn off not enough params warning
/*XLATON*/

/*MACROS*/
Begin_Service_Table(VPICD)

VPICD_Service	(VPICD_Get_Version, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Virtualize_IRQ, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Set_Int_Request, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Clear_Int_Request, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Phys_EOI, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Get_Complete_Status, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Get_Status, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Test_Phys_Request, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Physically_Mask, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Physically_Unmask, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Set_Auto_Masking, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Get_IRQ_Complete_Status, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Convert_Handle_To_IRQ, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Convert_IRQ_To_Int, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Convert_Int_To_IRQ, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Call_When_Hw_Int, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Force_Default_Owner, VxD_LOCKED_CODE)
VPICD_Service	(VPICD_Force_Default_Behavior, VxD_LOCKED_CODE)

VPICD_Service	(VPICD_Auto_Mask_At_Inst_Swap)
VPICD_Service	(VPICD_Begin_Inst_Page_Swap)
VPICD_Service	(VPICD_End_Inst_Page_Swap)
VPICD_Service	(VPICD_Virtual_EOI, VxD_LOCKED_CODE)	// 4.0 service
VPICD_Service	(VPICD_Get_Virtualization_Count)
VPICD_Service	(VPICD_Post_Sys_Critical_Init, LOCAL)
VPICD_Service	(VPICD_VM_SlavePIC_Mask_Change, VxD_LOCKED_CODE)

End_Service_Table(VPICD)
/*ENDMACROS*/

/*XLATOFF*/
#pragma warning (default:4003)		// turn on not enough params warning
#pragma warning (disable:4035)		// turn off no return code warning

/*
 *  This function is a macro for efficiency.  The parameters passed are
 *  the variables the version (USHORT), flags (ULONG), and maximum IRQ
 *  number (ULONG) are put.
 *
 */

#define	VPICD_Get_Version(ver, fl, cMaxIRQ) \
{ \
    VxDCall(VPICD_Get_Version) \
    __asm xchg [ver],ax \
    __asm xchg [fl],ebx \
    __asm xchg [cMaxIRQ],ecx \
}

//HIRQ static __inline
HIRQ static
VPICD_Virtualize_IRQ(PVID pvid)
{
    __asm {
	mov edi,[pvid]
	VxDCall(VPICD_Virtualize_IRQ)
    	jnc short vvi10
    	xor eax,eax
    vvi10:
    }
}

void static __inline
VPICD_Set_Int_Request(HIRQ hirq, HVM hvm)
{
    __asm mov eax,[hirq]
    __asm mov ebx,[hvm]
    VxDCall(VPICD_Set_Int_Request)
}

void static __inline 
VPICD_Clear_Int_Request(HIRQ hirq, HVM hvm)
{
    __asm mov eax,[hirq]
    __asm mov ebx,[hvm]
    VxDCall(VPICD_Clear_Int_Request)
}

void static __inline
VPICD_Phys_EOI(HIRQ hirq)
{
    __asm mov eax,[hirq]
    VxDCall(VPICD_Phys_EOI)
}

ULONG static __inline
VPICD_Get_Complete_Status(HIRQ hirq, HVM hvm)
{
    __asm mov eax,[hirq]
    __asm mov ebx,[hvm]
    VxDCall(VPICD_Get_Complete_Status)
    __asm xchg eax,ecx			// trashed ECX for compiler
}

ULONG static __inline
VPICD_Get_Status(HIRQ hirq, HVM hvm)
{
    __asm mov eax,[hirq]
    __asm mov ebx,[hvm]
    VxDCall(VPICD_Get_Status)
    __asm xchg eax,ecx			// trashed ECX for compiler
}

ULONG static __inline
VPICD_Test_Phys_Request(HIRQ hirq)
{
    __asm mov eax,[hirq]
    VxDCall(VPICD_Test_Phys_Request)
    __asm sbb eax,eax			// EAX == 0, interrupt request clear
}

void static __inline
VPICD_Physically_Mask(HIRQ hirq)
{
    __asm mov eax,[hirq]
    VxDCall(VPICD_Physically_Mask)
}

void static __inline
VPICD_Physically_Unmask(HIRQ hirq)
{
    __asm mov eax,[hirq]
    VxDCall(VPICD_Physically_Unmask)
}

void static __inline
VPICD_Set_Auto_Masking(HIRQ hirq)
{
    __asm mov eax,[hirq]
    VxDCall(VPICD_Set_Auto_Masking)
}

ULONG static __inline
VPICD_Get_IRQ_Complete_Status(ULONG irqn)
{
    __asm xor ecx,ecx
    __asm mov eax,[irqn]
    VxDCall(VPICD_Get_IRQ_Complete_Status)
    __asm xchg eax,ecx			// trashed ECX for compiler
}

ULONG static __inline
VPICD_Convert_Handle_To_IRQ(HIRQ hirq)
{
    __asm mov eax,[hirq]
    VxDCall(VPICD_Convert_Handle_To_IRQ)
    __asm xchg eax,esi			// trashed ESI for compiler
}

ULONG static __inline
VPICD_Convert_IRQ_To_Int(ULONG irqn, HVM hvm)
{
    __asm {
	mov eax,[irqn]
	mov ebx,[hvm]
	VxDCall(VPICD_Convert_IRQ_To_Int)
	jnc short cii10
	xor eax,eax		// returns 0 if invalid IRQ number
    cii10:
    }
}

ULONG static __inline
VPICD_Convert_Int_To_IRQ(ULONG intn)
{
    __asm {
	mov eax,[intn]
        VxDCall(VPICD_Convert_Int_To_IRQ)
	jnc short cii10
	xor eax,eax
	dec eax			// returns -1 if vector not mapped to any IRQ
    cii10:
    }
}

PFN static __inline
VPICD_Call_When_Hw_Int(PFN pfn)
{
    __asm mov esi,[pfn]
    VxDCall(VPICD_Call_When_Hw_Int)
    __asm mov eax,esi
}

ULONG static __inline
VPICD_Force_Default_Owner(HIRQ hirq, HVM hvm)
{
    __asm mov eax,[hirq]
    __asm mov ebx,[hvm]
    VxDCall(VPICD_Force_Default_Owner)
    __asm cmc
    __asm sbb eax,eax		// EAX != 0 success, EAX == 0 failure
}

void static __inline
VPICD_Force_Default_Behavior(HIRQ hirq)
{
    __asm mov eax,[hirq]
    VxDCall(VPICD_Force_Default_Behavior)
}

ULONG static __inline
VPICD_Auto_Mask_At_Inst_Swap(HIRQ hirq)
{
    __asm mov eax,[hirq]
    VxDCall(VPICD_Auto_Mask_At_Inst_Swap)
    __asm cmc
    __asm sbb eax,eax		// EAX != 0 success, EAX == 0 failure
}

void static __inline
VPICD_Begin_Inst_Page_Swap(void)
{
    VxDCall(VPICD_Begin_Inst_Page_Swap)
}

void static __inline
VPICD_End_Inst_Page_Swap(void)
{
    VxDCall(VPICD_End_Inst_Page_Swap)
}

ULONG static __inline
VPICD_Get_Virtualization_Count(ULONG intn)
{
    _asm mov	eax,[intn]
    VxDCall(VPICD_Get_Virtualization_Count)
}

#pragma warning (default:4035)		// turn on no return code warning

/*XLATON*/